import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import React, { useRef } from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
var BASE_CLASS = 'sui-AtomCheckbox';

var AtomCheckbox = function AtomCheckbox(_ref) {
  var _cx;

  var _ref$checked = _ref.checked,
      checked = _ref$checked === void 0 ? false : _ref$checked,
      CheckedIcon = _ref.checkedIcon,
      disabled = _ref.disabled,
      id = _ref.id,
      _ref$intermediate = _ref.intermediate,
      intermediate = _ref$intermediate === void 0 ? false : _ref$intermediate,
      IntermediateIcon = _ref.intermediateIcon,
      _ref$isNative = _ref.isNative,
      isNativeProp = _ref$isNative === void 0 ? false : _ref$isNative,
      name = _ref.name,
      _ref$onChange = _ref.onChange,
      onChangeFromProps = _ref$onChange === void 0 ? function () {} : _ref$onChange,
      props = _objectWithoutPropertiesLoose(_ref, ["checked", "checkedIcon", "disabled", "id", "intermediate", "intermediateIcon", "isNative", "name", "onChange"]);

  var inputRef = useRef();
  var hasNotCustomIcons = !CheckedIcon && !IntermediateIcon;
  var isNative = isNativeProp || hasNotCustomIcons;
  var isIntermediate = intermediate && !checked;

  var updateNativeIndeterminate = function updateNativeIndeterminate() {
    inputRef.current && (inputRef.current.indeterminate = isIntermediate);
  };

  var handleChange = function handleChange(ev) {
    // Handler doesn't necessarily trigger render, but browser could still set
    // native indeterminate property which may end up in a mismatch between it
    // and the component's prop, so native value should be kept updated here.
    updateNativeIndeterminate();
    var _ev$target = ev.target,
        checked = _ev$target.checked,
        name = _ev$target.name;
    if (!disabled) onChangeFromProps(ev, {
      name: name,
      value: checked
    });
  };

  var className = cx(BASE_CLASS, (_cx = {
    'is-checked': checked,
    'is-disabled': disabled
  }, _cx[BASE_CLASS + "--native"] = isNative, _cx)); // Keep native indeterminate property updated every render

  updateNativeIndeterminate();
  return React.createElement("label", {
    className: className
  }, !isNative && checked && React.createElement(CheckedIcon, null), !isNative && isIntermediate && React.createElement(IntermediateIcon, null), React.createElement("input", Object.assign({
    ref: inputRef,
    type: "checkbox",
    id: id,
    name: name || id,
    disabled: disabled,
    checked: checked,
    intermediate: isIntermediate ? 'intermediate' : '',
    onChange: handleChange
  }, props)));
};

AtomCheckbox.displayName = 'AtomCheckbox';
export default AtomCheckbox;